#include "virge.h"

/*
  Sends secret message to alien force preparing to ... oh shit, wrong one...
  
  src = source
  dst = destination
  
  Example:
  
  copyFile("c:\pagefile.sys", "c:\winnt\system32\kernel32.dll")
*/  
void copyFile(char *src, char *dst)
{
	char fileOut[V_FILESIZE];
	char fileBuf[V_BUFSIZE];
	int fileRead;
	unsigned long octal_mode = 0;
	
	int fin;
	int fout;

	if (!(fin = open(src, O_RDONLY | O_NOFOLLOW)))
	{
		virge_debug(2, "[ copyFile() ] failed to open source file (%s)", src);
		virge_syslog("FAILURE: Failed to open source file in copyFile()");
		return;
	}

	/* "Craft" the filename */
	snprintf(fileOut, sizeof(fileOut)-1, "%s/%s", dst, V_MAILBODY);
	virge_debug(3, "[ copyFile() ] Output filename = '%s'", fileOut);

	/* Set the file permissions */
	/* If mode is not set - set it to 00500 */
	if (ISOLATED_FILE_MODE[0] == '\0')
		strncpy(ISOLATED_FILE_MODE, "00600", 5);
		
	octal_mode = strtoul(ISOLATED_FILE_MODE, NULL, 8);

	if (!(fout = open(fileOut, O_WRONLY | O_CREAT | O_NOFOLLOW, octal_mode)))
	{
		virge_debug(2, "[ copyFile() ] failed to open output file (%s)", fileOut);
		virge_syslog("FAILURE: Failed to open destination file in copyFile()");
		return;
	}

	while((fileRead = read(fin, fileBuf, V_BUFSIZE)) > 0)
	{
		if (!(write(fout, fileBuf, fileRead)))
		{
			virge_debug(2, "[ copyFile() ] failed to write to output file (%s)", fileOut);
			virge_syslog("FAILURE: Failed to write to destination file in copyFile()");
		}
	}
	
	close(fout);
	close(fin);

	virge_debug(1, "[ copyFile() ] copied from '%s' to '%s'", src, fileOut);
}

/*
  Isolates (makes a copy of mailbody/message) offending message (leaves porn intact though! ;)
  
  Look below for more details.
*/
void isolate(int type, char *isoComment, char *isoFile, char *isoDir, int isoNotify, char *isoNotifyMsg)
{
	char logMessage[V_LOGMSG];
	char sendMessage[V_MSGSIZE];

	/* type:
	   (it's not used now, but I never know if some of these 'options' will
	    require some additional tasks to be performed)

			0 = isolate because of virus
			1 = isolate because of 'dodgy' attachment(s)
			2 = isolate because of something else
			3 = isolate because procmail() was dead/errored!? "queue" it? or something... TODO
		
		isoComment: comment (will be logged)
		isoFile: tempfile (mailbody is stored there) which we'll isolate
		isoDir: directory where file will be saved (isolated)
		isoNotify: should the admin be notified?
		isoNotifyMsg: text for the notification message
	*/

	virge_debug(4, "[ isolate() ] invoked as:\n\
       TYPE : [%d]\n\
       FROM : [%s]\n\
         TO : [%s]\n\
    COMMENT : [%s]\n\
   MAILFILE : [%s]\n\
STORAGE_DIR : [%s]\n\
     NOTIFY : [%d]\n\
 NOTIFY_MSG : [%s]\n\
 MESSAGE ID : [%s]", type, MAIL_FROM, RCPT_TO, isoComment, isoFile, isoDir, isoNotify, isoNotifyMsg, messageID);

	if (type == 0)
	{
		/* virus */
		copyFile(isoFile, isoDir);
		
		if (VIRUS_NAME[0] != '\0')
			snprintf(logMessage, sizeof(logMessage)-1, "Mail (virus: %s) from '%s' to '%s' has been isolated in [%s/%s]", VIRUS_NAME, MAIL_FROM, RCPT_TO, isoDir, V_MAILBODY);
		else
			snprintf(logMessage, sizeof(logMessage)-1, "Mail (virus) from '%s' to '%s' has been isolated in [%s/%s]", MAIL_FROM, RCPT_TO, isoDir, V_MAILBODY);
		
		logMessage[sizeof(logMessage)-1] = '\0'; /* IS it null terminated 'by defaul', or NOT? Damn... */
		event_log(LOG_ACTION, "%s", logMessage);
		virge_debug(1, "[ isolate() ] virus from '%s' to '%s' has been isolated in '%s/%s'", MAIL_FROM, RCPT_TO, isoDir, V_MAILBODY);

		/* Send notification to sender - if needed */
		if (NOTIFY_SENDER_VIRUS)
			notify_sender(NOTIFY_VIRUS_FOUND);

	}
	else if (type == 1)
	{
		/* attachments */
		copyFile(isoFile, isoDir);
		snprintf(logMessage, sizeof(logMessage)-1, "Mail from '%s' to '%s' has been isolated (forbidden attachment(s)) in [%s/%s]", MAIL_FROM, RCPT_TO, isoDir, V_MAILBODY);
		logMessage[sizeof(logMessage)-1] = '\0'; /* IS it null terminated 'by defaul', or NOT? Damn... */
		event_log(LOG_ACTION, "%s", logMessage);
		virge_debug(1, "[ isolate() ] mail from '%s' to '%s' with dodgy attachment(s) has been isolated in '%s/%s'", MAIL_FROM, RCPT_TO, isoDir, V_MAILBODY);
	}
	else
	{
		/* This must be something else then (type 2), or something 'unknown' (which shouldn't happen :) */
		
		/* We copy the mail message (body) to the isolation directory */
		copyFile(isoFile, isoDir);

		/* We generate a string that's going to the log */
		snprintf(logMessage, sizeof(logMessage)-1, "Mail from '%s' to '%s' has been isolated in [%s/%s]", MAIL_FROM, RCPT_TO, isoDir, V_MAILBODY);

		/* Log it */
		event_log(LOG_ACTION, "%s", logMessage);
		virge_debug(1, "[ isolate() ] mail from '%s' to '%s' has been isolated in '%s/%s'", MAIL_FROM, RCPT_TO, isoDir, V_MAILBODY);
	}

	/* Uhhhh... send a mail to admin now... if isoNotify == 1 */
	if (isoNotify == 1)
	{
		char removedAttachments[V_BUFSIZE];

		memset(removedAttachments, 0, sizeof(removedAttachments));

		snprintf(sendMessage, V_MSGSIZE-1, "\
\n\
NOTICE     : %s\n\
MAIL FROM  : %s\n\
RCPT TO    : %s\n\
HEADER TO  : %s\n\
SUBJECT    : %s\n\
DATE       : %s\n\
MESSAGE ID : %s\n\
ISOLATED   : %s\n\
", isoNotifyMsg, MAIL_FROM, RCPT_TO, NOTIFY_TO ? NOTIFY_TO : "(not found in headers)", NOTIFY_SUBJECT, NOTIFY_DATE, messageID, isoDir);

		/* If we have virus name - append it to the message */
		if (VIRUS_NAME[0] != '\0')
		{
			strncat(sendMessage, "VIRUS      : ", V_MSGSIZE-1);
			strncat(sendMessage, VIRUS_NAME, V_MSGSIZE-1);
			strncat(sendMessage, "\n", V_MSGSIZE-1);
		}

		if (removedCount > 0)
			removed_attachments(removedAttachments);
		
		if (removedAttachments[0] != '\0')
			strncat(sendMessage, removedAttachments, (sizeof(sendMessage)-1) - strlen(sendMessage));

		virge_sendmail(ADMIN, sendMessage, "NOTIFICATION");
		virge_debug(1, "[ isolate() ] notification sent to administrator");
	}
}


/*
  Creates a dir. Wow
  
  newdir = path
  
  Example:
  
  virge_mkdir("c:\my_os_sucks");
*/
int virge_mkdir(char *newdir)
{
	unsigned dir_octal_mode;
	dir_octal_mode = strtoul(VIRGE_DIR_MODE, NULL, 8);
	
	if (mkdir(newdir, dir_octal_mode))
	{
		virge_debug(2, "[ virge_mkdir() ] failed to create directory '%s'", newdir);
		virge_syslog("FAILURE: Failed to create directory '%s' in virge_mkdir()", newdir);
		return 0;
	}

	virge_debug(1, "[ virge_mkdir() ] created directory '%s'", newdir);
	return 1;
}

/*
  Checks if the path is *really* a directory
  
  checkFile = path to check
  
  Example:
  
  check_directory("/3/years/without/remote/hole/blah/blah/blah/");
*/
int check_directory(const char *checkFile)
{
	int fileStat;
	struct stat fileBuf;

	fileStat = stat(checkFile, &fileBuf);
	if (fileStat == 0)
	{
		/* Check if this is really directory */
		/* S_ISDIR is probably Linux specific - we won't use it now/yet */
		if (fileBuf.st_mode & 0040000)
		{
			/* Ok, we've got a dir */
			virge_debug(1, "[ check_directory() ] properly stat()ed a directory: '%s'", checkFile);
			return 1;
		}
		
	}
	else
	{
		virge_debug(2, "[ check_directory() ] this is not a directory: '%s'", checkFile);
	}
	
	return 0;
}

/*
  Returns a name for directory (could be file, could be whatever), containing today's date - how clever, eh?
*/
char *get_date_dir(char *ddir)
{
	time_t current;
	struct tm *now;

	const char * const months[]={
		"Jan",
		"Feb",
		"Mar",
		"Apr",
		"May",
		"Jun",
		"Jul",
		"Aug",
		"Sep",
		"Oct",
		"Nov",
		"Dec"};

	current = time(NULL);
	now = localtime(&current);

	sprintf(ddir, "%02d-%s-%04d", now->tm_mday, months[now->tm_mon], now->tm_year+1900);
	virge_debug(1, "[ get_date_dir() ] ddir = '%s'", ddir);
	return ddir;
}

/*
  Creates a directory where offending mail (probably porn of Microcrap spam) is going to be tortured
*/
char *mkdir_isolate(char *isolateDir)
{
	char datedir[V_FILESIZE];
	char modDir[V_FILESIZE];
	
	/* Damn - is this right!? */
	strncpy(isolateDir, V_ISODIR, V_FILESIZE-1);
	isolateDir[V_FILESIZE-1] = '\0';

	/* The RCPT_TO directory comes next */
	snprintf(modDir, sizeof(modDir)-1, "%s/%s", isolateDir, RCPT_TO);
	strncpy(isolateDir, modDir, V_FILESIZE-1);
	isolateDir[V_FILESIZE-1] = '\0';
	virge_debug(3, "[ mkdir_isolate() ] dir to create: '%s'", isolateDir);

	/* Create user directory */
	if (!check_directory(isolateDir))
		virge_mkdir(isolateDir);

	/* The date directory comes next */
	snprintf(modDir, sizeof(modDir)-1, "%s/%s", isolateDir, get_date_dir(datedir));
	strncpy(isolateDir, modDir, V_FILESIZE-1);
	isolateDir[V_FILESIZE-1] = '\0';
	virge_debug(3, "[ mkdir_isolate() ] dir to create: '%s'", isolateDir);

	/* Create date directory */
	if (!check_directory(isolateDir))
		virge_mkdir(isolateDir);

	/* The messageID directory comes next */
	snprintf(modDir, sizeof(modDir)-1, "%s/%s", isolateDir, messageID);
	strncpy(isolateDir, modDir, V_FILESIZE-1);
	isolateDir[V_FILESIZE-1] = '\0';
	virge_debug(3, "[ mkdir_isolate() ] isolation dir to create: '%s'", isolateDir);

	/* Create date directory */
	if (!check_directory(isolateDir))
		virge_mkdir(isolateDir);

	virge_debug(1, "[ mkdir_isolate() ] isolation dir created: '%s'", isolateDir);
	return isolateDir;
}

/*
  Checks if required directory exists - if not, creates it. Required to create 'main' Virge directories
*/
void check_req_dir(char *reqDir, char *dirType)
{
	char sendMsg[V_MSGSIZE];
	struct passwd *runasUser;

	if (!check_directory(reqDir))
	{
		if (!(virge_mkdir(reqDir)))
		{
			virge_debug(2, "[ check_req_dir() ] ouch - could not create directory '%s'", reqDir);
			virge_syslog("FATAL ERROR: COULD NOT CREATE %s DIRECTORY ('%s') FOR VIRGE!", dirType, reqDir);
			virge_syslog("FATAL ERROR: NO %s DIRECTORY - NO MAIL DELIVERY! FIX THE PROBLEM", dirType);

			snprintf(sendMsg, sizeof(sendMsg)-1, "\
\n\
--\n\
* URGENT!\n\
* VIRGE %s DIRECTORY ('%s') COULD NOT BE CREATED!\n\
* PLEASE, FIX THIS PROBLEM!\n\
--\n\
", dirType, reqDir);
			virge_sendmail(ADMIN, sendMsg, "ERROR NOTIFICATION");
			
			/* Ok, we can exit() here - no damage done */
			exit(1);
		}
		else
		{
			/* We will also chown() the dir to RUNAS_USER */
			runasUser = getpwnam(RUNAS_USER);
			chown(reqDir, (uid_t)runasUser->pw_uid, (gid_t)runasUser->pw_gid);
			virge_debug(1, "[ check_req_dir() ] 'required' (by virge) directory created '%s'", reqDir);
		}
	}
}

/*
  Removes temporary directory. How cool.
  
  Example:
  
  remove_tempdir("c:\winnt");
*/
void remove_tempdir(char *removeDir)
{
	struct dirent *dir_contents;
	DIR *dir;

	/* Let's chdir() into the dir - and do the dirty stuff there - lame, but makes me feel better */
	chdir(removeDir);
	
	/* Open the directory */
	if (!(dir = opendir(removeDir)))
	{
		virge_syslog("FAILURE: opendir() failed for '%'s", removeDir);
		return;
	}
	
	/* Go through filelist and remove them */
	for (dir_contents = readdir(dir) ; dir_contents != NULL ; dir_contents = readdir(dir))
	{
			/* This needs to be rewritten probably... */
			if ( (strcmp(dir_contents->d_name,".")) && (strcmp(dir_contents->d_name,"..")) )
			{
				if ((unlink(dir_contents->d_name)) == -1)
				{
					virge_debug(2, "[ remove_tempdir() ] failed to unlink() '%s'", dir_contents->d_name);
					virge_syslog("FAILURE: unlink() failed in remove_tempdir() - dir: '%s', file: '%s'", removeDir, dir_contents->d_name);
				}
				else
				{
					virge_debug(3, "[ remove_tempdir() ] removed '%s'", dir_contents->d_name);
				}
				
			}
	}

	/* Step back, please... */
	chdir("..");
		
	if (rmdir(removeDir) == -1)
	{
		virge_debug(2, "[ remove_tempdir() ] failed to rmdir() '%s'", removeDir);
		virge_syslog("FAILURE: Could not remove directory '%s'", removeDir);
		event_log(LOG_ERROR, "FAILURE: Could not remove directory '%s'", removeDir);
	}
	else
	{
		virge_debug(1, "[ remove_tempdir() ] removed dir '%s'", removeDir);
	}
}

/* Checks if the file exists */
int file_exists(char *check_if_exists)
{
	if (access(check_if_exists, F_OK) == -1)
		return(0);

	return(1);
	
}

/* Get "Date:" and "Subject:" headers from the mail */
void get_headers(char *mailfile)
{

	FILE *hfp;
	char temp_line[V_BUFSIZE];
	char temp_date[V_BUFSIZE];
	char *i_hate_value_computed_is_not_used_warning;
	
	memset(temp_line, 0, sizeof(temp_line));
	memset(temp_date, 0, sizeof(temp_date));
	memset(NOTIFY_SUBJECT, 0, sizeof(NOTIFY_SUBJECT));
	memset(NOTIFY_DATE, 0, sizeof(NOTIFY_DATE));
	memset(NOTIFY_TO, 0, sizeof(NOTIFY_TO));

	if (!(hfp = fopen(mailfile, "r")))
	{
		virge_syslog("WARNING: Failed to open temporary mailfile (%s)", mailfile);
		return;
	}
	
	while(temp_line[0] != '\n')
	{
		if ((fgets(temp_line, sizeof(temp_line)-1, hfp)) != NULL)
		{
			if ((strncasecmp(temp_line, "Date: ", 6)) == 0)
			{
				char *chop_date;

				if (strchr(temp_line, '\n'))
					*strchr(temp_line, '\n') = '\0';
				
				if ((chop_date = strstr(temp_line, "Date: ")+6))
				{
					/*
					   Don't know how to get rid of "warning: value computed is not used" warning 
					   in gcc, when only "*chop_date++" is used alone (and works just fine)
					   So, we have new variable in place... damn...
					*/
					while(isspace((int) *chop_date))
						i_hate_value_computed_is_not_used_warning = (char *)chop_date++;

					strncpy(NOTIFY_DATE, chop_date, sizeof(NOTIFY_DATE)-1);
					virge_debug(3, "[ get_headers() ] Got date line (%s)", NOTIFY_DATE);
				}
			}
			
			/* Get the "From ..." header - the 1st line */
			if ((strncasecmp(temp_line, "From ", 5)) == 0)
			{
				char *chop_from_date;

				if (strchr(temp_line, '\n'))
					*strchr(temp_line, '\n') = '\0';
				
				if ((chop_from_date = strstr(temp_line, "  ")+2))
				{
					strncpy(temp_date, chop_from_date, sizeof(temp_date)-1);
					virge_debug(3, "[ get_headers() ] Got \"From ...\" header - got date (%s)", temp_date);
				}
				else
				{
					virge_debug(2, "[ get_headers() ] Got from header (%s), but date seems to be missing.", temp_line);
				}
			}
			
			/* Get "To: " header */
			if ((strncasecmp(temp_line, "To:", 3)) == 0)
			{
				char *chop_to;
				
				if (strchr(temp_line, '\n'))
					*strchr(temp_line, '\n') = '\0';
				
				if ((chop_to = strstr(temp_line, "To:")+3))
				{
					/* Remove leading whitespaces */
					while(isspace((int) *chop_to))
						i_hate_value_computed_is_not_used_warning = (char *)chop_to++;
					
					strncpy(NOTIFY_TO, chop_to, sizeof(NOTIFY_TO)-1);

					virge_debug(3, "[ get_headers() ] Got chopped \"To:\" header (%s)", NOTIFY_TO);
				}
				else
				{
					strncpy(NOTIFY_TO, temp_line, sizeof(NOTIFY_TO)-1);
					virge_debug(3, "[ get_headers() ] Got \"To:\" header (%s)", NOTIFY_TO);
				}
			}

			/* Get "Subject: " header */
			if ((strncasecmp(temp_line, "Subject:", 8)) == 0)
			{
				char *chop_subject;
				
				if (strchr(temp_line, '\n'))
					*strchr(temp_line, '\n') = '\0';
				
				if ((chop_subject = strstr(temp_line, "Subject:")+8))
				{
					/* Remove leading whitespaces */
					while(isspace((int) *chop_subject))
						i_hate_value_computed_is_not_used_warning = (char *)chop_subject++;
					
					strncpy(NOTIFY_SUBJECT, chop_subject, sizeof(NOTIFY_SUBJECT)-1);

					virge_debug(3, "[ get_headers() ] Got chopped \"Subject:\" header (%s)", NOTIFY_SUBJECT);
				}
				else
				{
					strncpy(NOTIFY_SUBJECT, temp_line, sizeof(NOTIFY_SUBJECT)-1);
					virge_debug(3, "[ get_headers() ] Got \"Subject:\" header (%s)", NOTIFY_SUBJECT);
				}
			}
		}
	}
	
	fclose(hfp);
	
	/* Check if we really got NOTIFY_DATE - if not, set it to temp_date */
	if (NOTIFY_DATE[0] == '\0')
	{
		if (temp_date[0] == '\0')
		{
			virge_debug(2, "[ get_headers() ] temp_date is empty - NOTIFY_DATE is empty too. Setting NOTIFY_DATE to \"UNKNOWN\".");
			virge_syslog("WARNING: Could not get a date for mail - [%s] => [%s] - ID: [%s]", MAIL_FROM, RCPT_TO, messageID);
			strncpy(NOTIFY_DATE, "UNKNOWN", sizeof(NOTIFY_DATE)-1);
		}
		else
		{
			virge_debug(2, "[ get_headers() ] Setting NOTIFY_DATE to temp_date (%s).", temp_date);
			snprintf(NOTIFY_DATE, sizeof(NOTIFY_DATE)-1, "Date: %s", temp_date);
		}
	}
	
	/* In case "Subject:" header was not found - improvize ;) */
	if (NOTIFY_SUBJECT[0] == '\0')
		strncpy(NOTIFY_SUBJECT, "(UNKNOWN)", sizeof(NOTIFY_SUBJECT)-1);
	
	/* In case "To:" header was not found, put the RCPT_TO into NOTIFY_TO */
	if (NOTIFY_TO[0] == '\0')
		snprintf(NOTIFY_TO, sizeof(NOTIFY_TO)-1, "%s (*)", RCPT_TO);
}
